> For the complete documentation index, see [llms.txt](https://docs.openbrush.app/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.openbrush.app/developer-notes/open-brush-ascanvas-notes.md).

# Open Brush AsCanvas Notes

AsCanvas\[pointer.transform] = foo *(where foo is in Canvas space)*:

Sets pointer transform to foo

RHS convert transform to canvas space TrTransform:

* TrTransform xf\_CS = Coords.AsCanvas\[transform]; // Get transform in canvas space, and write to scene.
* TrTransform rAttachPoint\_CS = App.Scene.ActiveCanvas.AsCanvas\[InputManager.Brush.Geometry.ToolAttachPoint];
* m\_xfLocal = m\_canvas.AsCanvas\[transform];
* TrTransform xf\_CS = canvas.AsCanvas\[p.m\_Script.transform];
* m\_Pointers\[i].m\_StraightEdgeXf\_CS = Coords.AsCanvas\[m\_Pointers\[i].m\_Script.transform];
* var xfPointer\_CS = canvas.AsCanvas\[script.transform];
* TrTransform xf\_CS = Coords.AsCanvas\[TransformForStroke(stroke)];
* return Coords.AsCanvas\[InputManager.m\_Instance.GetBrushControllerAttachPoint()].translation;
* m\_vOriginalPos\_CS = Coords.AsCanvas\[transform].translation;
* var xf\_CS = Coords.AsCanvas\[transform];
* return ChangeBasis(App.Scene.AsScene\[xfInput], basis, basisInverse)
* m\_Rotation\_SS = App.Scene.AsScene\[transform].rotation;
* CanvasTransformInSceneSpace = App.Scene.AsScene\[App.Instance.m\_CanvasTransform],
* m\_Transform\_SS = App.Scene.AsScene\[m\_Owner];
* Vector3 vOwnerEulers\_SS = App.Scene.AsScene\[m\_Owner].rotation.eulerAngles;

LHS convert canvas space TrTransform to transform:

* m\_canvas.AsCanvas\[transform] = m\_xfLocal;
* canvas.AsCanvas\[m\_MainPointerData.m\_Script.transform] = mainPointerXf\_CS;
* Coords.AsCanvas\[transform] = xf\_CS;
* App.Scene.AsScene\[transform] = m\_Transform\_SS;


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.openbrush.app/developer-notes/open-brush-ascanvas-notes.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
